Subject: Re: [PATCH 0/8] odb: track multi-pack-indices via their object sources

From: Taylor Blau <[email-masked]>
Date: Thu, 10 Jul 2025 19:58:42 -0400

On Wed, Jul 09, 2025 at 03:04:44PM -0700, Junio C Hamano wrote:
> Patrick Steinhardt <[email-masked]> writes:
>
> > This patch series thus refactors the codebase to stop tracking MIDX's
> > globally. Instead, they are being pushed down one level so that every
> > `struct odb_source` has an optional MIDX itself. This simplifies some of
> > our code and will make it easier in a future iteration to move the data
> > into a packfile-specific object source backend.
> >
> > This series is built on top of a30f80fde92 (The eighth batch,
> > 2025-07-08) with "ps/object-store" at 841a03b4046 (odb: rename
> > `read_object_with_reference()`, 2025-07-01) merged into it.
>
> You do not have to deal with it just yet, but FYI, another topic in
> flight has a commit that adds a few more callers to a function this
> topic renames away.  Namely, 5ee86c27 (repack: exclude cruft pack(s)
> from the MIDX where possible, 2025-06-23).

Yup, there are a handful of new get_local_multi_pack_index() calls in
that topic.

> If this topic needs to be rerolled after the other topic graduates
> to 'master', we may need to see this topic rebased on a newer
> 'master' with something like the attached patch squashed in, but
> because the other topic is at least a few more days away from
> 'next', and it might still need another final finishing touch
> iteration, let's keep these two topics independent from each other a
> bit longer, and let me deal with this trivial semantic conflict
> resolution, at least for now.
>
> Thanks.
>
> diff --git a/builtin/repack.c b/builtin/repack.c
> index a74b2ca7f3..21723866b9 100644
> --- a/builtin/repack.c
> +++ b/builtin/repack.c

Assuming that in these three cases that the first entry in
the_repository->objects->sources refers to the local object database,
then I agree with the proposed changes.

Thanks for flagging it :-).

Thanks,
Taylor